{BBS2.inc file}


procedure definecs;
  var
    ch: char;
    prompt: line;

  begin
    ch := null;
    while cts and not (ch in ['Q','Y']) do begin
      lineout('The following input is NOT echoed until CR (RETURN) is pressed!');
      prompt := 'Enter character(s) that will clear your screen (end with CR): ';
      controls := true;
      cs := getinput(prompt, 11, noecho);
      controls := false;
      clearsc;
      ch := getcap(cr + lf + 'Did that do it (Y/N/Quit)? ');
    end;
    if ch = 'Q' then cs := lnfd;
  end;

procedure definebs;

  begin
    repeat
      flush;
      controls := true;
      stringout('Type your backspace key: ');
      bs := charin(echo);
      controls := false;
      lineout(space);
    until not ((bs in [cr, tab, space, '0'..'9', 'A'..'Z', 'a'..'z']) and cts);
  end;

procedure setwidth;

  var temp: integer;

  begin
    repeat
      temp := getint(132, 0, 'Enter your terminal width (chars/line): ');
    until (temp in [0, 20..132]) or not cts;
    if temp <> 0 then width := temp;
  end;


procedure setvideo;

  var loop: byte;
      inch: integer;
      temp: name;

  function ctlchar(ch: char): name;

    begin
      if ch > #127 then ch := chr(ord(ch) and 127);
      case ch of
        null..#31   : ctlchar := '^' + chr(ord(ch) + 64);
        space..#126 : ctlchar := ch;
        #127        : ctlchar := '<DEL>';
      end;
    end;

  procedure dispcontrol(ch: char);

    begin
      if ch < #128 then stringout(ctlchar(ch))
        else stringout(ctlchar(ch) + '(with 8th bit set)');
    end;

  begin
    repeat
      clearsc;
      lineout('Terminal parameters:' + cr + lf);
      lineout('1 - Upper case only: ' + yn[caps]);
      lineout('2 - Line feeds sent: ' + yn[lf = lnfd]);
      lineout('3 - Prompt bell ON : ' + yn[bl = bell]);
      stringout('4 - Backspace char.: ');
      dispcontrol(bs);
      lineout(space);
      stringout('5 - Clear Screen   : ');
      for loop := 1 to length(cs) do dispcontrol(cs[loop]);
      lineout(space);
      str(width:3, temp);
      lineout('6 - Terminal width : ' + temp);
      lineout(space);
      inch := getint(6, 0, 'Enter number of parameter to change (0 to quit): ');
      case inch of
        1: caps := not caps;
        2: if lf = lnfd then lf := null else lf := lnfd;
        3: if bl = bell then bl := null else bl := bell;
        4: definebs;
        5: definecs;
        6: setwidth;
      end;
    until (inch = 0) or not cts;
    if cts then lineout('New definitions are saved by [G]oodbye command.');
  end;

procedure chat;
  var
    count  : byte;
    inch   : char;
    i,j    : integer;
    tempbb : boolean;
  begin
    inch := null;
    tempbb := ScreenControlx;
    ScreenON;
    File_Control_Enable := false;
    clearsc;
    lineout('Entering Chat Mode: Summoning Sysop...');
    flush;
    count := 1;
    lineout('-----  SYSOP CHAT -------');
    repeat
      count := count + 1;
      charout(bell);
      messagebeep(2);
      timedin(4);
      if inready then inch := charin(noecho);
    until (count > 10) or (inch <> null);
    if (count > 10) then
    begin
      lineout('Sysop is not available...'+cr+lf);
    end
    else
    begin
      lineout('CTL-C aborts at any time.'+cr+lf);
      while cts and (inch <> abort) do begin
        inch := charin(echo);
        if inch = cr then sendout(lf);
      end;
    end;
    if not tempbb then ScreenOFF;
    File_Control_Enable := true;
  end;

procedure newpass;
  var
    temp   : name;
    prompt : line;
  begin
    repeat
      prompt := 'Enter the password you want on this system: ';
      password := allcaps(getinput(prompt, 14,noecho));
      prompt := cr + lf + 'Enter it again, to be sure: ';
      temp := allcaps(getinput(prompt, 14, noecho));
      if temp <> password then lineout('Passwords did not match.');
    until (temp = password) or not cts;
    lineout('New password is saved when the [G]oodbye command is executed.');
  end;

procedure listusers;
  var
    tempid : sysid;
    inch   : name;
  const sp = '                                        ';
  begin
    if cts then begin
      clearsc;
      FileMode := 0;  {0=Read only 2=ReadWrite}
      reset(idfile);
      str(filesize(idfile):4, inch);
      lineout(inch + ' users registered.');
      lineout(' ');
      read(idfile,tempid);
      while cts and not(eof(idfile) or cancelled) do begin
        read(idfile,tempid);
        str(tempid.acc:1, inch);
        if access = sysop then
        begin
          stringout(inch + ' ');
          if inch='0' then  lineout(copy(tempid.user+sp,1,25)+
                 copy(tempid.callsign+sp,1,10) +tempid.lsto + '** Deleted **');
        end;
          if inch<>'0' then
          begin
            stringout(copy(tempid.user+sp,1,25)  +
                      copy(tempid.callsign+sp,1,10) + tempid.lsto + '  ');
             if access = sysop then lineout(' ') else lineout(tempid.address2);
          end;
        if access = sysop then begin
             lineout('  ' + tempid.address1);
             lineout('  ' + tempid.address2);
             lineout('  ' + tempid.telephone);
             lineout('-----------------------------------------------');
          end;
      end;
    end;
  end;

procedure enterpass;
  var
    temp:  name;
    tries: byte;
  begin
    tries := 0;
    lineout(space);
    repeat
      if tries > 0 then stringout('Incorrect - try again: ');
      tries := tries + 1;
      temp := allcaps(getinput('Enter your password: ', 14, noecho));
    until (temp = idrec.pass) or (tries = 3) or not cts;
    if (temp <> idrec.pass) then hangup;
  end;


procedure defaults;
  begin
    StatusLine1(1,'Screen OFF...');
    Statusline1(2,'Defaults set.');
    StatusLine1(3,'...');
    StatusLine1(4,'...');
    ScreenOFF;
    lf := lnfd;
    bl := null;
    cs := lnfd;
    bs := bksp;
    caller := '***';
    add1   := 'NO Street Address';
    add2   := 'NO City, State ZIP';
    tele   := '(___) ___-____';
    calls  := 'NONE';
    expert := false;
    caps := false;
    width := 80;
    access := newuser;
    lastmess := 0;
    usernum := 0;
    messopen := false;
    filesopen := false;
    printon := false;
    inbuffer := '';
    cancelled := false;
    controls := false;
    file_control_enable := true;
    dispcaller;
  end;

procedure getdefaults;
  begin
    enterpass;
    if cts then begin
      with idrec do begin
        password := pass;
        expert := (exfl = 0);
        access := acc;
        cs := clr;
        bs := bsp;
        lf := lnf;
        caps := upc;
        width := wid;
        lastmess := lstm;
        calls := callsign;
        add1 := address1;
        add2 := address2;
        tele := telephone;
        if clockin then lineout('Last on: ' + lsto);
      end;
    end;
  end;

procedure introduce;
  begin
    lineout(cr + lf + 'Getting new user password & terminal info:');
    if cts then begin
      newpass;
      setvideo;
      if caller = 'SYSOP' then access := sysop else access := newuser;
    end;
  end;

procedure signon(var caller: person);
  var ch: char;
      tries: byte;
  begin
    ch := space;
    tries := 0;
    repeat
      tries := tries + 1;
      repeat
        caller := allcaps(getinput(
        'What is your FIRST and LAST name? ', 28, echo));
      until (length(caller) > 6) or (caller = 'SYSOP') or not cts;
      if cts then begin
        usernum := findid(caller);
        if (local or openBBS) and (usernum=0) then
          ch:=getcap(caller + ': is this correct (Y/N)? ');
      end;
      if (tries >= 3) and (usernum=0) and not openBBS then hangup;
    until (usernum > 0) or (ch = 'Y') or not cts;
    if cts then begin
      if usernum = 0 then introduce else getdefaults;
      if access = twit then begin
        lineout('User ' + caller + ' has been denied system access.');
        lineout('User must re-apply to gain access again.');
        apply;
        savedefaults;
        hangup;
        dispcaller;
      end;
    end;
  end;


procedure endcall;
  begin
    if clockin then begin
      clock(offmonth, offdate, offhour, offmin, offsec);
      timeoff := time(offmonth, offdate, offhour, offmin, offsec);
    end;
  end;

procedure relog;
  begin
    endcall;
    if clockin then begin
      clock(onmonth, ondate, onhour, onmin, onsec);
      timeon := time(onmonth, ondate, onhour, onmin, onsec);
    end;
    signon(caller);
    MessageMenu(true);
  end;
{
procedure BulletinMenu;
var inch : char;
 begin
    StatusLine(1,'BulletinMenu...');
    Statusline1(2,'...');
    StatusLine1(3,'...');
    StatusLine1(4,'...');
   repeat
     flush;
     if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
     outfile(bulletin);
     inch := getcap('main\information\BULLETIN MENU - Input selection or PRESS RETURN to EXIT:  ');
     if inch <> cr then outfile('\BBS\INFO\BULLET'+inch+'.TXT');
   until ((inch = '-') or (inch = cr) or not cts);
   flush;
 end;
}

procedure InformationMenu;
var prompt : line;
     inch  : char;
begin
    StatusLine(1,'InformationMenu...');
    Statusline1(2,'...');
    StatusLine1(3,'...');
    StatusLine1(4,'...');
  repeat
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      if ((not expert) and (inbuffer = '')) then outfile(infomenu);
      prompt := cr + lf + 'main\INFORMATION MENU (?-help) cmd: ';
      if not expert then prompt := prompt + '[B,G,H,F,M,W,Y,#,?,-] : ';
      inch := getcap(prompt);

      case inch of
       'B': TCPIP(1); {BulletinMenu; }
       'G': disconnect;
       'H': outfile(helpfile);
       'F': XFinger;
       'M': outfile(Welcome1);
       'U': listusers;
       'W': outfile(welcome);
       'Y': outfile(sysinfo);
       '?': outfile(infomenu);
       '-': begin end;
       cr : begin end;
       else  ErrorCode(inch);
     end;
    until ((inch ='-') or (inch = cr) or not cts);

end;

procedure SystemMenu;
 var prompt : line;
     inch   :char;
begin
  StatusLine(1,'SystemMenu...');
  Statusline1(2,'...');
  StatusLine1(3,'...');
  StatusLine1(4,'...');
  repeat
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      if  ((not expert) and (inbuffer = '')) then outfile(SYSTmenu);
      prompt := cr + lf + 'main\SYSTEM MENU (?-help) cmd: ';
      if not expert then prompt := prompt + '[A,C,G,I,P,Q,X,#,?,-] : ';
      inch := getcap(prompt);

      case inch of
         'A': apply;
         'C': chat;
         'G': disconnect;
         'I': setvideo;
         'P': newpass;
         'Q': if access = sysop then relog;
         'X': begin expert := not expert; end;
         '#': begin {status;} showtime; connecttime; end;
         '?': if expert then outfile(SYSTmenu);
         '@': if access=sysop then sysoponly;
         '!': if access=sysop then printon := not printon;
         '-': begin end;
         cr : begin end;
        else ErrorCode(inch);
       end;
     until ((inch ='-') or (inch = cr) or not cts);
  end;

procedure command;
  var
    prompt: line;
    inch  : char;
  begin
    StatusLine(1,'CommandMenu...');
    Statusline1(2,'...');
    StatusLine1(3,'...');
    StatusLine1(4,'...');
    while cts do begin
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      if ((not expert) and (inbuffer = '')) then outfile(mainmenu);
      prompt := cr + lf + 'MAIN MENU (?-help) cmd: ';
      if not expert then prompt := prompt + '[F,G,I,M,S,Z,?] : ';
      flush;
      inch := getcap(prompt);
      case inch of
        'M': MessageMenu(false);  { electronic mail }
        'F': filesys;
        'G': disconnect;
        'I': InformationMenu;
        'S': SystemMenu;
        'Z': XPacketMenu;
        '?': if expert then outfile(mainmenu);
        else  ErrorCode(inch);
      end; {case}
      if inch in ['M','F','I','S','Z'] then ConnectTime;
    end; {while cts}
  end; {command}
{eof}