program filesys;

  const
  numsects = 13;
  type
   sectname = array[1..numsects] of string[40];
   filedrivenamedef = array[1..numsects] of string[25];

  const
    mostfiles = 500;
    drivecap = 5000; {Kbyte capacity of files drive}
    ksize = 1; {minimum increment of file size in Kbytes}



 type
    filerec = record
               title: name;
               description : person;
               submit: integer;
               date: name;
               size: integer;
               accesses: integer;
               ASCII: boolean;
               section: byte;
               Xpublic: boolean;
             end;
    channel = array[0..127] of byte;

  var
    filefile: file of filerec;
    filetab: array[0..mostfiles] of filerec;
    filebuff: array [0..16] of channel;
    enddir: integer;
    inch : byte;



  procedure addfile(filename: name;descr : person; sectnum: byte; xmodem: boolean);
    begin
      with filetab[enddir + 1] do begin
        title := filename;
        if (length(descr) > 1) then description := descr;
        submit := usernum;
        if clockin then date := timeon;
        assign(datafile, filedrive + filename);
        FileMode := 0;  {0=Read only 2=ReadWrite}
        reset(datafile);
        size := filesize(datafile);
        close(datafile);
        accesses := 0;
        section := sectnum;
        Xpublic := true;
      end;
    end;

procedure newfile;
    var
      filename   : name;
      successful : boolean;
      sectnum    : byte;
      descr      : person;
      innum      : integer;
      UploadMode : integer;
      xmodem     : boolean;





 procedure installfile(filename : name);
    var descr    : person;
        sectnum  : byte;
    begin
            addfile(filename,descr, sectnum, true);
            enddir := enddir + 1;
    end;


  procedure initfile;
    var
      loopvar: integer;
      temp: name;
    begin
      if filesopen then closefile;
      lineout('Initializing file system...');
      loopvar := 0;
      verylongname := filedrive + 'FILES.BBS';
      assign(filefile, verylongname);
      FileMode := 0;  {0=Read only 2=ReadWrite}
      {$I-} reset(filefile) {$I+};
      if IOresult = 0 then begin
        while not eof(filefile) do begin
          loopvar := loopvar + 1;
          read(filefile, filetab[loopvar]);
        end;
        close(filefile);
      end;
      enddir := loopvar;
      filesopen := true;
    end;

  procedure closefile;
    var loopvar: integer;
    begin
      if filesopen then
      begin
        rewrite(filefile);
        if enddir > 0 then
          for loopvar := 1 to enddir do write(filefile, filetab[loopvar]);
      close(filefile);
      end;
      filesopen := false;
    end;

procedure jiffyloopkill;
var loopvar : integer;
begin
   for loopvar := 1 to enddir do
   begin
     write('[',filedrive,filetab[loopvar].title,']  ');
     filetab[loopvar].section := filesection;
     if not File_Exists(filetab[loopvar].title) then
     begin
       jiffykillfile(loopvar);
       exit;
     end
     else writeln;
   end;
 end;

procedure jiffy;
var  done : integer;
begin
   repeat
     done := enddir;
     jiffyloopkill;
   until done = enddir;
end;


  begin
  {  initfile;  }
    filedrive := '';
    listfilesections;
    getsect;
    StatusLine(1,'FileMenu...');
    Statusline1(2,'...');
    StatusLine1(3,'...');
    StatusLine1(4,'...');
    if ((not expert) and (inbuffer = '')) then outfile(filemenu);
    repeat
      lineout(space);
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      comch := getcap('main\FILE MENU (?-help) cmd: ');
      if ((comch in['U']) and (access<file_reg)) then
      begin
        lineout('You must be a level 3 access this function........');
        lineout('Please send the SYSOP a note requesting level 3...');
      end;

      case comch of
       'A' : GetSect;
       'D' : directory;
       'S' : begin
               transmitfile;
             end;
       'T' : begin
              textdump;
             end;
       'H' : outfile(filehelp);
       'G' : inbuffer := '-;G';
       '?' : outfile(filemenu);
       'U' : if access>reg then newfile;
       'K' : if access = sysop then killfile;
       'I' : if access = sysop then installfile('');
       'E' : if access = sysop then editheader('');
       'J' : if access = sysop then jiffy;
      end;
    until (comch = '-') or (comch = cr) or not cts;
    if cts then lineout('Closing file system...');
    closefile;
  end;
