var
  cancelled : boolean;
  inbuffer  : line;


Function IString(sss : integer): line ;
var ss : line;
begin
  str(sss,ss);
  IString := ss
end;

procedure sendout(ch: char);
{Character output - bypasses word-wrap; also performs
 "pause" and "abort" input character checks.}
  var temp: char;
      tctl: boolean;
      i   : integer;
  begin
    if not cancelled then begin

      if inready and file_control_enable then begin
        temp := charin(noecho);
        if (temp = pause) or (upcase(temp) = 'S') then
        begin
          tctl := controls;
          controls := true;
          temp := charin(noecho);
          controls := tctl;
        end
        else cancelled := true;
       {    added cancelled := true     *****   }
      {  if (temp = abort) or (upcase(temp) = 'C') then cancelled := true;  }
      end;
      xmitchar(ch);
      If ScreenControlx then
      begin
        if not (ch in [bell, lf, cr]) then write(ch);
      {  if printon then write(lst, ch); }
        if (ch = cr) then writeln;
      end;
    end;
  end;

procedure flushbuff;

  var
    outpointer: byte;

  begin
    if length(buffer) > lastspace then
      for outpointer := lastspace + 1 to length(buffer) do
        sendout(buffer[outpointer]);
    lastspace := length(buffer);
  end;

procedure resetbuff;

  begin
    bufpointer := 0;
    lastspace := 0;
    charcount := 0;
    buffer := '';
  end;

procedure charout(ch:char);

{Character output using word-wrap}

  var
    buffull   : boolean;
    temp      : string150;

  begin
    if caps then ch := upcase(ch);
    if not (ch in [null..#31]) then charcount := succ(charcount);
    if (ch = bs) and (charcount > 0) then charcount := charcount - 1;
    buffer := buffer + ch;
    bufpointer := length(buffer);
    buffull := (charcount + 2 > width);
    if buffull then begin
      if (lastspace > 0)
        then begin
          buffer := copy(buffer, lastspace + 1, bufpointer - lastspace);
          charcount := length(buffer);
          lastspace := 0;
          end {then}
        else begin
          flushbuff;
          resetbuff;
        end; {else}
      sendout(cr);
      sendout(lf);
    end; {if}
    if ch in [null..space] then flushbuff;
    if (ch=cr) then resetbuff;
  end;

procedure stringout;
  var
    charpos: integer;
  begin
       for charpos := 1 to length(message) do charout(message[charpos]);
  end;

procedure lineout; (* "forward" declared in MACHDEP *)

  begin
    stringout(message);
    charout(cr);
    charout(lf);
  end;

function timedin(duration : integer): boolean;
           {returns false if no character received in within
            'duration' milliseconds: used for XMODEM and input timeout.}
  begin
   TimeOutTimer := false;
   SetTimer(CrtWindow,0,duration,nil);
   while ((not TimeOutTimer) and (not inready)) do WindowsMessageHandler;
   timedin := inready and cts;
  end;

procedure press_return;
var temp : char;
    i : integer;
begin
  stringout('<Press_Return>');
  for i := 1 to 15 do flushbuff;
  temp := charin(noecho);
  stringout(cr + '                ' + cr);
end;

function charin;      { (withecho : boolean) in function prototype }
  var
    ch: char;
    countime: integer;
    i : integer;
  begin
    ch := null;
    countime := 0;
    repeat
      if timedin(10000) then ch := recvchar else countime := countime + 1;
      if keypressed then ch := readkey;
      if countime > 12 then
      begin
        lineout(cr+lf+'System has detected lack of activity and has timed out...');
        StatusLine(1,'System timeout');
        hangup;
      end;
      if not cts then ch := cr;
      if (ch <> bs) and not controls then ch := chr(ord(ch) and 127);
    until (ch in [abort, pause, bs, tab, cr, space..#127])
      or (controls and (ch <> null));
    if (ch = #127) and not controls then ch := bs;
    if ch = #$8D then ch := cr;
    if withecho then begin
      sendout(ch);
      if ch = bs then begin sendout(' '); sendout(bs); end;
    end;
    charin := ch;
  end;

procedure flush;
  var junk: char;

  begin
    repeat
     begin
        if keypressed then junk := readkey;
     end;
     until not keypressed;
    purgeline(ComBase);
  end;

function inputstring(withecho: boolean): line;
  var
    temp:    line;
    ch:      char;

  begin
    temp := '';
   { flush;      deleted to improve input response  }
    repeat
      ch := charin(noecho);
      if (ch = bs) then begin
        if length(temp) > 0 then begin
          temp := copy(temp, 1, length(temp) - 1);
          if withecho then begin
            sendout(bs);
            sendout(space);
            sendout(bs);
          end;
        end;
      end
      else begin
        if (ch <> cr) and (length(temp) < 80)
        and ((ch in [tab, space..#126]) or controls) then begin
          if ch = tab then repeat
            temp := temp + space;
            if withecho then sendout(space);
          until (length(temp) mod 8) = 0
          else begin
            temp := temp + ch;
            if withecho then sendout(ch);
          end; {else}
        end
        else if (ch <> cr) then sendout(bell);
      end;
      if length(temp) > (width-10) then
      begin
        charout(bell);
        if local then messagebeep(0);
      end;
    until (ch = cr);
    charout(cr); charout(lf);
    inputstring := temp;
  end;

function getinput(prompt:line; maxlength:integer; withecho:boolean):line;

  var posn: integer;
      temp: char;

  begin
    if cancelled then begin
      cancelled := false;
      lineout(space);
    end;
    if inbuffer = '' then begin
      repeat
        cancelled := false;
        stringout(prompt);
        if bl = bell then stringout(bl);
      until cancelled = false;
      inbuffer := inputstring(withecho);
    end;
    if maxlength = 1 then begin
      if inbuffer = '' then temp := cr else begin
        temp := inbuffer[1];
        inbuffer := copy(inbuffer, 2, length(inbuffer)-1);
        if (length(inbuffer) > 1) and (inbuffer[1] = ';')
          then inbuffer := copy(inbuffer, 2, length(inbuffer)-1);
      end; {else}
      getinput := temp;
    end
    else begin
      posn := pos(';', inbuffer);
      if posn = 0 then posn := length(inbuffer) + 1;
      if posn > maxlength then begin
        posn := maxlength + 1;
        inbuffer := copy(inbuffer, 1, maxlength);
      end;
      getinput := copy(inbuffer, 1, posn - 1);
      if posn >= length(inbuffer)
        then inbuffer := ''
        else inbuffer := copy(inbuffer, posn + 1, length(inbuffer) - posn);
    end;
  end;

function allcaps(letters: person): person;
  var
    loop: byte;
    temp: person;
  begin
    temp := '';
    for loop := 1 to length(letters) do
      temp := temp + upcase(letters[loop]);
    allcaps := temp;
  end;


procedure check_modem;
var buffer : line;
    I      : integer;
    temp   : line;
begin
   setlocal;
   writeln(cr +'Begin Test....');
   buffer:= cr + 'AT &V' + cr;
   modem_cmd(buffer);
   {

   buffer := cr + 'AT\S' + cr;
   for i := 0 to 27 do
   begin
     str(i,temp);
     buffer := cr + 'AT S' + temp + '?' + cr;
     modem_cmd(buffer);
     delay(100);
   end;     }
   writeln('Finished Test');
   clearlocal;
 end;

procedure timeprint;
var tt : array[0..35] of char;
begin
  clock(month,date,hour,min,sec);
  StrPCopy(tt,time(month, date, hour, min, sec));
  SetDlgItemText(DialogWindow,id_Lsto,tt);
end;

procedure awaitcall;
  var
          i : integer;
     Opcode : char;
    getchar : char;
        junk: char;
     buffer : line;
       loop : byte;
begin
    getchar := #0;               {fix the 300 baud lockup problem }
    flush;
    Opcode := #0;
    clearmodem;
    StatusLine(1,'Waiting for call...');
    StatusLine1(3,'...');
    StatusLine1(4,'...');
    SetDlgItemText(DialogWindow,id_On,'...');
    repeat      {1: process incomming characters }
      repeat    {2: process special mouse commands }
        delay(1000);
        timeprint;
        if WMCommandWord <> 0 then messagebeep(0);
        case WMCommandWord of
           2001 :  begin
                      StatusLine(1,'Local control.');
                      StrPCopy(UserParameters.BaudStat,'Local');
                      setlocal;
                      WMCommandWord := 0;
                      exit;
                   end;
           2002 :  modem_cmd(cr + cr + 'AT'+cr);
           2003 :  check_modem;
           2004 :  begin
                    Writeln('Closing and Opening Telephone Port.....');
                     CloseCommPorts(1);
                     OpenCommPorts(1);
                     InitModem;
                   end;
           3000 :  ListCommentFile;
           6000 :  begin      { user access level control - local only }
                     Finger;
                   end;
           6001 :  begin               { generic finger control }
                      access := sysop;
                      setlocal;
                      local := true;
                      assign(idfile,'\BBS\IDS.BBS');
                      XFinger;
                      close(idfile);
                      local := false;
                      clearlocal;
                      defaults;
                   end;
           4001 :  begin               { read sysop messages }
                     assign(idfile,'\BBS\IDS.BBS');
                     FileMode := 0;  {0=Read only 2=ReadWrite}
                     reset(idfile);
                     caller := 'SYSOP';
                     access := sysop;
                     usernum := 1;
                     setlocal;
                     expert := true;
                     setlocal;
                     Messagemenu(true);
                     defaults;
                     clearlocal;
                     close(idfile);
                   end;
           5002 :  begin
                     StatusLine(1,'Local JNOS Bridge');
                     setlocal;
                     expert := true;
                     access := sysop;
                     calls := 'AA6ED';
                     msys('aa6ed.ampr.org',23);
                     defaults;
                     clearlocal;
                   end;
           5001 :  begin
                     WMCommandWord := 0;
                   end;
           5003 : begin        { modem direct access }
                    ScreenON;
                    WMCommandWord := 0;
                    repeat
                      if keypressed then  x_xmitchar(readkey);
                      if datardy then write(recvchar);
                    until WMCommandWord = 5003;
                    ScreenOFF;
                  end;
           9999 :  begin   { quit }
                     if id_yes = MessageBox(CrtWindow,'Do you wish to KILL BBS?','BBS Terminate',mb_YesNo)
                     then
                     begin
                       exitchar := abort;
                       exit;
                     end;
                   end;
          end;
          WMCommandWord := 0;
      until inready;   {2: end of processes mouse commands }

      { Now process Keyboard and RS-232 data    }
      if keypressed then Opcode := readkey else Opcode := recvchar;
      exitchar := Opcode;
      case opcode of
        '0' :  if baud = 300 then
               begin
                 StatusLine(2,'BaudRate = 2400');
                 baud := 2400;
                 getchar := 'D';
               end
               else StatusLine(2,'OK');
        '1' :  begin
                 getchar := 'A';
                 baud := 300;
               end;
        '2' :  StatusLine(2,'RING');
        '3' :  StatusLine(2,'No Carrier');
        '4' :  StatusLine(2,'Modem Error');
        '5' :  begin
                 StatusLine(2,'Baudrate = 1200');
                 getchar := 'C';
                 baud := 1200;
               end;
        '6' :  StatusLine(2,'No Dial Tone');
        '7' :  StatusLine(2,'Busy');
        '8' :  StatusLine(2,'No Answer');
        '9' :  begin
                 StatusLine(2,'Baudrate =  600');
                 getchar := 'B';
                 baud := 600;
                end;
        cr  :  if baud = 300 then StatusLine(2,'BaudRate = 300');
      else  StatusLine1(4,'{'+char(opcode)+'}');
    end;
    until cts; {1;  End of Looks for incomming characters }

    { Update the Status Windows with Baudrate  }
    if cts then
    begin
      StatusLine(1,'On line...');
      case getchar of
        'A'   :  StrPCopy(UserParameters.BaudStat,' 300');
        'B'   :  StrPCopy(UserParameters.BaudStat,' 600');
        'C'   :  StrPCopy(UserParameters.BaudStat,'1200');
        'D'   :  StrPCopy(UserParameters.BaudStat,'2400');
      end;

 end else Statusline(3,'CTS not detected...');
   { modemdelay(5000);   *** new external modem }
end;

procedure clearsc;
  begin
    stringout(cs);
    delay(500);   {allows time for slow terminal screen clears}
  end;

function getcap(prompt: line): char;
  var tempchar : line;
  begin
    tempchar := getinput(prompt, 1, echo);
    getcap := upcase(tempchar[1]);
  end;

function getint(nmax, star: integer; prompt: line): integer;

  var temp, test: integer;
      outstr, userin: name;

  begin
    str(nmax:4, outstr);
    repeat
      temp := 0;
      userin := getinput(prompt, 4, echo);
      val(userin, temp, test);
      if (temp > nmax) then lineout('Number too large: ' + outstr + ' maximum.');
    until ((test = 0) and (temp >= 0) and (temp <= nmax))
     or (userin = '*') or (userin = '') or (userin = '?') or not cts;
     if userin = '?' then getint := -1
      else if userin = '*' then getint := star
       else if test = 0 then getint := temp
        else getint := 0;
  end;

{Real-time clock support starts here...
 these routines must remain, even if there's
 no clock! To kill clock support, simply set
 "clockin" in BBS.PAS to false.}

type monthname = string[3];
     monames  = array[1..12] of monthname;

const months: monames = ('Jan','Feb','Mar','Apr','May','Jun',
                         'Jul','Aug','Sep','Oct','Nov','Dec');

function time(month, date, hour, min, sec: byte): name;

{Returns 14-character string containing time and date}

  var
    temps,
    tempm,
    tempd,
    temph: string[2];

  begin
    if clockin then begin
      str(sec:2,temps);
      str(min:2,tempm);
      str(hour:2,temph);
      str(date:2,tempd);
      if sec < 10 then temps := '0' + temps[2];
      if min < 10 then tempm := '0' + tempm[2];
      if date < 10 then tempd := '0' + tempd[2];
      time := temph + ':' + tempm + ':' + temps + ' ' + months[month] + tempd;
    end
    else time := '';
  end;

procedure showtime;

  var
    message: name;

  begin
    if clockin then begin
      clock(month, date, hour, min, sec);
      message := time(month, date, hour, min, sec);
      lineout('Time is: ' + message);
    end;
  end;

procedure calcconnect(var usehour, usemin, usesec: integer);

  begin
    clock(month, date, hour, min, sec);
    usemin := 0;
    usehour := 0;
    usesec := sec - onsec;
    if usesec < 0 then begin
      usesec := usesec + 60;
      usemin := -1;
    end;
    usemin := min - onmin + usemin;
    if usemin < 0 then begin
      usemin := usemin + 60;
      usehour := -1;
    end;
    usehour := hour - onhour + usehour;
    if usehour < 0 then usehour := usehour + 24;
  end;

procedure connecttime;

  var
    message: name;

  begin
    if clockin then begin
      calcconnect(usehour, usemin, usesec);
      message := copy(time(1, 1, usehour, usemin, usesec), 1, 8);
      lineout('Connect time: ' + message);
    end;
  end;


var   line_count  : integer;
procedure typefile(fname: longname; nowrap: boolean);
const buflen = 512;
var
   FilVar      :file;
   FileN       :string[30];
   Inbuf       :array [1..buflen] of char;
   InFile,
   OutFile     :integer;
   temp        : char;

  begin
    file_control_enable := true;
    line_count := 1;   { added by AA6ED for line control }
    Assign(FilVar,fname);
    FileMode := 0;  {0=Read only 2=ReadWrite}
    {$I-} Reset(FilVar,1); {I+}
    if IOresult <> 0 then lineout('Can''t find ' + fname + '!')
    else
    begin
      blockread(FilVar,Inbuf,buflen,InFile);
      while ((Infile > 0) and cts) do
       begin
         if (infile<buflen) then Infile := Infile - 1;
         for OutFile := 1 to Infile do
          begin
            charout(Inbuf[OutFile]);
            if (inbuf[outfile] = cr) then
            begin
               line_count := line_count + 1;
               if (line_count > 24) then
               begin
                 line_count := 1;
                 press_return;
               end;
            end;
          end;
          blockread(FilVar,Inbuf,buflen,InFile);
      end;
    end;

    lineout(lnfd);
    close(FilVar);
   { press_return;
    lineout(lnfd);  }
  end;



procedure outfile(fname: longname);

  begin
    typefile(fname, true);
  end;

function findid(caller: person): integer;

  var
    usernum: integer;
    index: integer;

  begin
    usernum := 0;
    index := 0;
    lineout('Searching userlist...');
    FileMode := 0;  {0=Read only 2=ReadWrite}
    {$I-} reset(idfile) {$I+};
    if IOresult <> 0 then rewrite(idfile);
    while (usernum = 0) and not eof(idfile) do begin
      index := index + 1;
      read(idfile, idrec);
      if idrec.user = caller then usernum := index;
      if idrec.callsign = caller then usernum := index; { optional callsign }
    end;
    findid := usernum;
  end;

function nextuser: integer;
  var temp: integer;
  begin
    stringout('Finding space for new user: ');
    temp := findid('***');
    if temp = 0 then nextuser := 1 + filesize(idfile) else nextuser := temp;
  end;

procedure savedefaults;
  begin
    if access > newuser then
    begin
      if usernum = 0 then usernum := nextuser;
      with idrec do begin
        user := caller;
        if expert then exfl := 0 else exfl := 255;
        if clockin then lsto := timeon;
        lstm := nextmess-1;
        pass := password;
        clr := cs;
        acc := access;
        bsp := bs;
        lnf := lf;
        upc := caps;
        wid := width;
        address1 := add1;
        address2 := add2;
        callsign := calls;
        telephone := tele;
      end;
      FileMode := 2;  {0=Read only 2=ReadWrite / AA6ED Last Modification}
      {$I-} reset(idfile); {$I+}
      if (IOResult = 0) then
      begin
        seek(idfile, usernum - 1);
        write(idfile, idrec);
      end
      else lineout('Problem in writing ID file, contact SYSOP...');
    end;
  end;

procedure disconnect;

  var
    ch: char;

  begin
    clearsc;
    ch := 'N';

    if access = newuser then
    begin
      ch := getcap(
      'You have not properly registered, Do you wish to re-APPLY now (Y/N)? ');
      if ch = 'Y' then
       begin
         Apply;
        end;
    end;

    if access > newuser then
    begin
      ch := getcap(
      'Do you want to leave comments to the Sysop BBS (Y/N)? ');
      if ch = 'Y' then
       begin
         inbuffer := 'E;SYSOP;COMMENTS;12;N;C;S;G;N';
         MessageMenu(false);
        end;
    end;

    if (ch = 'N') or (ch = 'Y') or not cts then begin
      connecttime;
      lineout('Thanks for calling, ' + caller);
      savedefaults;
      Delay(1000);
      hangup;
    end;
  end;
