

{=======================================================================

                         ASYNC

               Turbo Pascal Asynch Functions

========================================================================}

var       ComBase    : integer;
          NOSBase   : integer;
Const     ComAddress    : integer =  $3E8;
          NOSAddress    : integer =  $2F8;   {  $3F8;   }
          MSR = $06;         { xFE   Modem Status Register }

{ Checks for comm errors and writes any errors.                       }
procedure Error(E: Integer; C: PChar);
var
  S: array[0..100] of Char;
begin
  if E >= 0 then exit;
  Str(E, S);
  MessageBox(GetFocus, S, C, mb_Ok);
end;



function hex(number : integer): string;
var    i : integer;
       k : integer;
     res : string;
const ch : array[0..15] of char =
 ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
begin
   res[0] := #2;
   for i := 1 to 2 do
   begin
     res[3-i] := ch[number and $0f];
     number := number shr 4;
   end;
   hex := res;
end;

function hex4(number : integer): string;
var    i : integer;
       k : integer;
     res : string;
const ch : array[0..15] of char =
 ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
begin
   res[0] := #4;
   for i := 1 to 4 do
   begin
     res[5-i] := ch[number and $0f];
     number := number shr 4;
   end;
   hex4 := res;
end;

procedure purgeline(CID : integer);
begin
 { FlushComm(CID,0);  TX QUEUE }
  FlushComm(CID,1);
end;

{ this should really be global   }
var DCB : TDCB;

procedure setbaudrate(CID : integer; Config: line);
var
  Configx : array[0..80] of char;
begin
  StrPCopy(Configx,Config);
  StatusLine(4,'Port ' + Config);
  writeln('Config=' + Config +' CID=' , cid);
  BuildCommDCB(Configx, DCB);
  DCB.ID := CID;
  Error(SetCommState(DCB), configx);
  delay(500);
  purgeline(CID);
  delay(500);
end;


{-------------------- Open COM1 or COM2, a la Basic -----------------}
function MyOpenComm(Port,Config : line) : integer;
var CID : integer;
    Configx : array[0..80] of char;
    portx : array[0..80] of char;
begin
  StrPCopy(Configx,Config);
  StrPCopy(Portx,Port);
  BuildCommDCB(Configx, DCB);
  CID := OpenComm(Portx, 10000, 10);
  writeln(Port + ' ' + Config +' ' , cid,' DCB Flags = ',DCB.Flags);
  Error(CID, Configx);
  DCB.ID := CID;
  Error(SetCommState(DCB), 'Set Comm State');
  MyOpenComm := CID
end;

{ Open for Comm3 9600 Baud, No Parity, 8 Data Bits, 1 Stop Bit }
procedure OpenCom3;   {main modem port }
begin
  DCB.Flags := dcb_OutxCtsFlow;
  ComBase := MyOpenComm('COM3', 'com3:19200,n,8,1');
 {  ComBase := MyOpenComm('COM3', 'com3:4800,n,8,1'); }
  EscapeCommFunction(ComBase,SetRTS);     {  Set RTS, DTR, OUT2       }
  EscapeCommFunction(ComBase,SetDTR);
end;
{ Open for Comm2 2400 Baud, No Parity, 8 Data Bits, 1 Stop Bit }
procedure OpenCom1;
begin
  DCB.Flags := dcb_DtrDisable;
  NOSBase := MyOpenComm('COM2', 'com2:9600,n,8,1');
  EscapeCommFunction(NOSBase,ClrRTS);     {  Clr RTS, DTR, OUT2       }
  EscapeCommFunction(NOSBase,ClrDTR);
end;
{ Open everything Comm3 Comm2 }
procedure OpenCommPorts(which : integer);
begin
   case which of
   1: OpenCom3;  {main BBS Modem input }
   2: OpenCom1;   { was old null modem PACKET port }
   3: begin OpenCom3; OpenCom1; end;
   end;
end;
{---------------- Close any initialized COM -------------------------}

Procedure CloseCom3;
begin
  EscapeCommFunction(ComBase,ClrRTS);     {  Set RTS, DTR, OUT2       }
  EscapeCommFunction(ComBase,ClrDTR);
  CloseComm(ComBase);
end;
Procedure CloseCom1;
begin
  EscapeCommFunction(NOSBase,ClrRTS);     {  Set RTS, DTR, OUT2       }
  EscapeCommFunction(NOSBase,ClrDTR);
  CloseComm(NOSBase);
end;

Procedure CloseCommPorts(which : integer);
begin
  case which of
  1: CloseCom3;
  2: CloseCom1;
  3: begin CloseCom3; CloseCom1; end;
  end;
end;

function datardy: boolean;
var Stat: TComStat;
begin
  Stat.Flags := $FF;
  GetCommError(ComBase, Stat);
  datardy := Stat.cbInQue > 0;
end;


Function  recvchar: char;
var c : char;
Begin
  if datardy then
  begin
     ReadComm(ComBase, @C, 1);
     recvchar := C;
  end;
end;

function inready: boolean;
begin
  inready := keypressed or datardy;
end;

function outready : boolean ;
begin
  outready := true;
end;


{This function returns true if a carrier tone is present on the modem
 and is frequently checked to see if the caller is still present.
 It always returns "true" in the local mode.  The delays also provide for
 some of the spike noise that is present on telephone lines.......}


var cts_count: integer;      {  global variable }
function cts: boolean;
var cts_temp_var : boolean;

 function cts_port_status: boolean;
 begin
    cts_port_status := ((Port[ComAddress+MSR] and $80) = $80)
 end;

 begin
    cts_temp_var := local or cts_port_status;
    if cts_temp_var then cts_count := 0 else cts_count := cts_count + 1;
    if ((not cts_temp_var) and (cts_count < 5)) then
    begin
      delay(100);
      cts_temp_var := local or cts_port_status;
    end;
    cts := cts_temp_var;
  end;

procedure xmitchar(ch : char);
var xstatus : integer;
    i       : integer;
Begin
  if (not local and cts) then
  begin
  {   repeat
        WindowsMessageHandler; may cause interrupt interruption!
     until ((Port[ComAddress+MSR] and $10) = $10);   }
     xstatus := WriteComm(Combase, @ch, 1);
     if (xstatus = 0) then
     repeat
        WindowsMessageHandler;
     until (WriteComm(ComBase, @ch, 1) = 1);
   end;
end;

procedure xmit(x:byte);
begin
  xmitchar(chr(x));
  {  WindowsMessageHandler; }
end;

function inbyte: byte;
var temp: char;
begin
  repeat until inready or not cts;
  if keypressed then temp := readkey else
      if datardy then temp := recvchar;
  inbyte := ord(temp);
end;


{==========================  Modem Commands =========================}
procedure x_xmitchar(ch : char);
Var LSRreg: byte;
  begin
     WriteComm(ComBase, @ch, 1)
  end;

procedure x_stringout(buffer : line);
var loop: integer;  temp : char;
begin
  for loop := 1 to length(buffer) do
   begin
      temp := buffer[loop];
      {if temp <> cr then write(temp);}
      x_xmitchar(temp);
      delay(10);
   end;
end;

procedure x_quit;
begin
  CloseCommPorts(3);
  writeln(cr+'Problem encountered with accessing the MODEM!  Program Halted!');
  repeat  delay(8000); messagebeep(1); until keypressed;
  halt;
end;

procedure modemdelay(xxxx : integer);
  begin
    TimeOutTimer := false;
    SetTimer(CrtWindow,0,xxxx,nil);
    while ((not TimeOutTimer) and (not datardy)) do
                WindowsMessageHandler;
  end;

procedure initmodem; forward;

procedure modem_cmd(buffer : line);
var    i : integer;
    temp : char;
begin
   i := 0;
   repeat
     x_stringout(buffer);
     modemdelay(5000);
     if not datardy then i := i + 1;
   until (i = 2) or datardy;
 {  if i=1 then
   begin
      Hangup_seq;
      CloseCommPorts(1);
      OpenCommPorts(1);
      initmodem;
   end;
   if i=2 then x_quit;   serious problem with modem detected
   nosound;  }
   if datardy then
   begin
     write('[');
     repeat
        temp := recvchar;
        case temp of
          cr   : begin end;         { _write('<cr>');   }
          lnfd : begin end;         { _write('<lnfd>'); }
          else begin write(temp); modemdelay(50); end;
        end;
        delay(50);
     until not datardy;
     writeln(']');
   end;
end;

procedure clearmodem;
begin
   modem_cmd(cr + 'AT' + cr);
end;

procedure initmodem;        (* Modem Dependent *)
var init_string : line;
  begin
   { clearmodem;
    init_string := cr + 'AT X4 Q0 S2=126 S0=1 V0 E0 M1 &C1 &D2 &W' + cr;
    modem_cmd(cr + 'AT Z &F' + cr); **** old internal
    init_string := cr + 'AT Q0 S2=126 S0=3 V0 E0 M1' + cr;  }
    modem_cmd('ATZ' + cr);
    modemdelay(5000);
 {   modem_cmd('AT V0' + cr);
    modem_cmd('AT E0' + cr);
    modem_cmd('AT S2=126' + cr); }
    modem_cmd('AT S0=3' + cr);
  {  modem_cmd('AT M1' + cr);
    modem_cmd(init_string);
    modem_cmd(init_string);  *** let's see if this is unnecessary }

   {
                     DEFAULT CODES SENT TO MODEM
      &C1  - DCD carrier detect         X4     - extended command set
      Q0   - no result codes            S2=126 - tild '~' escape char
      S0=1 - rings to answer            V0     - numeric response code
      E0   - no echo in command mode    M1     - monitor speaker till connect
      &D3  - DTR disconnect & reset     &W     - writes config to memory
      &F   - Reset to factory defaults
   }
  end;


procedure dropRTS;
{ Lowers RS-232 RTS line - used to inhibit auto-answer
   and to cause modem to hang up }
  begin
      EscapeCommFunction(ComBase,ClrRTS);    {  Reset RTS, DTR, OUT2       }
      EscapeCommFunction(ComBase,ClrDTR);
  end;

procedure raiseRTS;
(* Raises RTS line to enable auto-answer *)
  begin
     EscapeCommFunction(ComBase,SetRTS);     {  Set RTS, DTR, OUT2       }
     EscapeCommFunction(ComBase,SetDTR);
  end;

procedure setlocal;
{Sets local flag true and inhibits modem auto-answer}
  begin
    modem_cmd(cr + 'AT H1 M0' + cr);
    local := true;
    ScreenON;
  end;

procedure clearlocal;
{Clears local flag and allows modem auto-answer}
  begin
    modem_cmd(cr + 'AT H0 M1' + cr);
    local := false;
    ScreenOFF;
  end;

procedure dispcaller;
{Displays caller's data on the diaglog panel}
 var xline : array[0..130] of char;
     LineIndex : integer;
  begin
    if caller <> '***' then
    begin
      StrPCopy(xline,IString(usercount) + '  ' +    {4}
                     timeon + '  ' +                {14}
                     IString(ord(access))+'  ' +     {4}
                     copy(caller+sp,1,25) +
                     copy(calls +sp,1,12) +
                     copy(add2  +sp,1,25) +
                     copy(tele  +sp,1,15) + cr + lnfd);
      if E900^.GetNumLines > 6 then E900^.DeleteLine(0);  { *** was 25 *** }
      E900^.SetSelection(1000,1000);   {   was 2650  }
      E900^.Insert(xline);
      Usercount := usercount + 1;
    end;
    UserParameter_Update;
  end;

procedure hangup_seq;
begin
  StatusLine(3,'Hangup sequence....');
  dropRTS;
  repeat until not cts;
  delay(50);
  raiseRTS;
end;

procedure hangup;
  begin
    if local then clearlocal else
    begin
       if cts then lineout('--- PLEASE DISCONNECT ---' + cr + lf);
       hangup_seq;
    end;
  end;

{*** END OF MACHDEP.INC *** }


