{$R-}    {Range checking off}
{$I+}    {I/O checking on}
{$N-}    {No numeric coprocessor}
{$M 44900,4000} {Windows stack/heap setting}
{x$S-} {no stack checking - program works}


program TurboBBS;

(*******************************************************************)
(*                                                                 *)
(*                 William H. Bytheway                             *)
(*                 11108 SE 184th Place                            *)
(*                 Renton, WA  98055                               *)
(*                                                                 *)
(*******************************************************************)

Uses
  BBSCrt  , Strings , WinDos, WinTypes , WinProcs ,odialogs,owindows {, wObjects } ;

const
  version   = ' 08.16.93a';

{$I BBSData.H}      { All initial constants variables and records }

 { FUNCTION PROTOTYPING : Declaration of forward functions   }
 function charin(withecho: boolean):char; forward;
 procedure lineout(message:  line); forward;
 function  IString(sss : integer): line ; forward;
 procedure hangup;        forward;
 procedure hangup_seq;    forward;
 procedure MainEngine;    forward;
 procedure CloseCommPorts(which:integer); forward;
 function  cts: boolean;  forward;
 function  hex(number : integer): string;                 forward;
 procedure Clock(var month,date,hour,min,sec: word);      forward;
 function  time(month, date, hour, min, sec: byte): name; forward;
 procedure StatusLine(linenr : integer; textline : line); forward;
 procedure OpenCommPorts(which: integer);             forward;
 function  getid(prompt: line): integer; forward;
 function  getint(nmax, star: integer; prompt: line): integer; forward;
 procedure stringout(message:line); forward;
 procedure chat; forward;
 procedure MessageMenu(listmine:boolean); forward;
 procedure defaults; forward;
 procedure msys; forward;
 procedure setlocal; forward;
 procedure clearlocal; forward;
 function allcaps(letters: person): person; forward;
 function getinput(prompt:line; maxlength:integer; withecho:boolean):line; forward;
 function inready: boolean;  forward;
 procedure messagebeep(selection : integer); forward;
 function datardy: boolean; forward;


{$R d:\bbs\WinBBS.res}
{$I Control.Inc}
{$I Beeper.Inc}
{$I Machdep.Inc}
{$I IO.INC}
{$I MailSys.Inc}
{$I FileSys.Inc}
{$I FileList.Inc}
{$I TCPIP.Inc}
{$I Packet.Inc}
{$I SysOnly.Inc}
{$I Apply.Inc}
{$I BBS2.Inc}

procedure Engine;
begin
    if cts then
    begin
      if clockin then begin
        clock(onmonth, ondate, onhour, onmin, onsec);
        timeon := time(onmonth, ondate, onhour, onmin, onsec);
      end;
      flush;
      resetbuff;
      if cts then lineout(cr + lnfd + cr +lnfd + cr + lnfd +
        'Turbo Pascal WinBBS for Windows version ' + version);
      if cts and not cancelled then outfile(welcome);
      if cts then signon(caller);
     { if cts then apply; }
     if (cts and (access < reg)) then apply else dispcaller;
    {  if cts then dispcaller;  included in apply   }
      if cts then
      begin
        if access = HAM_BBS then
        begin
          MSYS;
          inbuffer := 'GN';
        end
        else
        begin
          if inbuffer = '' then
          begin
            if cts and (access > File_reg) then
            begin
              outfile(WelcomePacket);
              verylongname := getinput('Press RETURN to continue  ',1,noecho);
            end;
            if cts and not cancelled then
            begin
              outfile(Welcome1);
              verylongname := getinput('Press RETURN to continue  ',1,noecho);
            end;
            if cts then MessageMenu(true);
          end;  { nothing in inbuffer }
        end;  { not a BBS }
      end;   { cts exclusion }
      if cts then command;       { MAIN MODEM ENGINE }
      endcall;
      {$I-} reset(idfile); {$I+}   { check for the open file   }
      if IOresult = 0 then close(idfile);
      defaults;
    end;
end;

procedure Stuck_CTS;
begin
    if cts then
    begin
       StatusLine(4,'CTS High, System initiated hangup...');
       hangup_seq;
       Delay(100);
       CloseCommPorts(1);
       OpenCommPorts(1);
       InitModem;
    end
    else StatusLine(4,'Hang Up Complete....');
end;

procedure MainEngine;
begin
  UserCount := 1;
  StrPCopy(WindowTitle,'WinBBS-NEW');
  ScreenSize.Y := 50;
  writeln('Ready to open');
  OpenCommPorts(3);
  EscapeCommFunction(NOSBase,ClrRTS);      {  Reset RTS, DTR, OUT2       }
  EscapeCommFunction(NOSBase,ClrDTR);
  writeln('Ports Opened');
  initmodem;
  exitchar := space;
  local := false;
  verylongname := '\BBS\IDS.BBS';
  assign(idfile, verylongname);
  defaults;
  messagebeep(4);
  repeat
    awaitcall;
    Engine;
    Stuck_CTS;
  until exitchar = abort;
  CloseCommPorts(3);
  messagebeep(5);
end;


{  MAIN PROGRAM   }
var ch: char;
begin
  MBBSApp.Init(AppName);
  MBBSApp.Run;
  MBBSApp.Done;
end.
